package com.yyrh.sdk;

import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.graphics.BitmapFactory;
import android.os.Build;
import android.os.Handler;
import android.util.Log;
import android.widget.Toast;

import com.yyrh.advertisement.AdvertiseManager;
import com.yyrh.constant.URLConstants;
import com.yyrh.factory.SdkManager;
import com.yyrh.imei.ImeiUtil;
import com.yyrh.pay.WvPayYyrhDialog;
import com.yyrh.sdk.callback.RealNameMsgCallback;
import com.yyrh.sdk.callback.ShowPolicyCallback;
import com.yyrh.sdk.callback.UserPolicyCallback;
import com.yyrh.ui.AutoLoginDialog;
import com.yyrh.ui.PrivacyPolicyDialog;
import com.yyrh.ui.SingleButtonDialog;
import com.yyrh.ui.floatmenu.FloatItem;
import com.yyrh.ui.floatmenu.FloatLogoMenu;
import com.yyrh.ui.floatmenu.FloatMenuView;
import com.yyrh.ui.floatmenu.WvPageListDialog;
import com.yyrh.ui.userlist.DatabaseHelper;
import com.yyrh.utils.InspectSimulator;
import com.yyrh.utils.ResourceUtil;
import com.yyrh.utils.ScheduledWorker;
import com.yyrh.utils.TosUtil;
import com.yyrh.utils.Utils;
import com.yyrh.constant.SDKSettings;
import com.yyrh.networking.NetRequestApi;

import com.yyrh.sdk.callback.InitCallback;
import com.yyrh.ui.ConstantDialog;
import com.yyrh.ui.CustomExitGameDialog;
import com.yyrh.utils.YYLog;
import com.yythird.sdk.ChannelSDK;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.concurrent.TimeUnit;


import static com.yyrh.constant.Constants.LOGOUT;


import static com.yyrh.constant.SDKSettings.initConfig;
import static com.yyrh.constant.SDKSettings.isOpenFloatView;
import static com.yyrh.constant.SDKSettings.isOpenRealName;

import static com.yyrh.constant.SDKSettings.isVefityRealName;

public class YyrhSdkManager {
    private static YyrhSdkManager manager = null;


    FloatLogoMenu mFloatMenu;
    String HOME = "用户中心";
    String FEEDBACK = "切换账号";


    String CLOSE = "隐藏";
    String[] MENU_ITEMS = {HOME,FEEDBACK,CLOSE};
    private  Context context;

    ArrayList<FloatItem> itemList = new ArrayList<>();

    public static ScheduledWorker sScheduledWorker = null;

    private YyrhSdkManager(Context context) {
       super();
        this.context = context;
    }

    public static YyrhSdkManager defaultManager(Context context) {
        if (manager == null) {
            synchronized (YyrhSdkManager.class) {
                if (manager == null) {
                    manager = new YyrhSdkManager(context);
                }
            }
        }

        return manager;
    }
    public void queryOrder(final String order, final HashMap<String, Object> payMap){

        String status = Utils.getParamCnfValuebyKey(context, "YyrhAdParam.cnf",
                "QUERY_ORDER");
        if (status.equals("YES")){
            new Handler().postDelayed(new Runnable() {

                @Override
                public void run() {
                    NetRequestApi.queryOrder(order,payMap);
                }
            }, 5000);
        }



    }


    public void yyrhShowPolicy(final Activity activity, final UserPolicyCallback userPolicyCallback){

        YYLog.i("yyrhShowPolicy ");

        final SharedPreferences sp = activity.getSharedPreferences("xiyuan", Activity.MODE_PRIVATE);
        String  isShowPolicy = sp.getString("yyrhShowPolicy", "");

        if (isShowPolicy.equals("")){

            NetRequestApi.initAgreement(activity,new ShowPolicyCallback() {

                @Override
                public void onShow(String agreement_url) {
                    YYLog.i("need to display the policy");
                    new PrivacyPolicyDialog(activity, ResourceUtil.getStyleId(activity, "xy_base_dialog"), agreement_url,
                            new PrivacyPolicyDialog.OnClosePageListener() {
                                @Override
                                public void onUserAgreePolicy() {

                                    YYLog.i("User agree policy");
                                    SharedPreferences.Editor editor = sp.edit();
                                    editor.putString("yyrhShowPolicy", "1");
                                    editor.commit();


                                    userPolicyCallback.onAgree();
                                }

                                @Override
                                public void onUserDisagreePolicy() {
                                    YYLog.i("User disagree policy");
                                    userPolicyCallback.onDisagree();
                                }
                            }).show();


                }

                @Override
                public void onHide() {
                    YYLog.i(" don't need to display the policy");
                    userPolicyCallback.onHide();
                }

                @Override
                public void onError() {
                    YYLog.i(" request policy error");

                    SingleButtonDialog.Builder builder = new SingleButtonDialog.Builder(activity);
                    builder.setPositiveButton(new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {

                            System.exit(0);

                        }
                    });
                    builder.Create(activity.getString(ResourceUtil.getStringId(activity, "xy_network_error_tip"))).show();


                    userPolicyCallback.onError();
                }
            });



        }else {
            YYLog.i("The user has agreed to the policy");
            userPolicyCallback.onAgree();
        }


    }
    public void yyrhInitDevice(final Activity activity, boolean isDebug){

        SDKSettings.isDebug = isDebug;

        String isdebug	=	Utils.GetApplicationMetaData(context, "xy_debug");
        if (isdebug.equals("true")){
            SDKSettings.isDebug = true;
        }
        SDKSettings.initSetting(activity);

        if (Build.VERSION.SDK_INT > 28) {
            ChannelSDK.getInstance().SDKGetOaid();
        }else{
            SDKSettings.imei =  ImeiUtil.getImei(context);
            SDKEntry.getSdkInstance().tCallBack.onGetOaidCallback(true,SDKSettings.imei);
        }


    }


    public void yyrhInit(final Activity activity){



        NetRequestApi.init(activity, new InitCallback() {
            @Override
            public void onInitSuccess(String msg) {
                SdkManager.defaultManager(activity).onInitSuccess(activity);
                ChannelSDK.getInstance().SDKInitSuccess(msg);
                SDKEntry.getSdkInstance().initCall.onInitSuccess(msg);

            }

            @Override
            public void onInitFailed(String msg) {

                ChannelSDK.getInstance().SDKInitFail(msg);
                SDKEntry.getSdkInstance().initCall.onInitFailed(msg);

                SingleButtonDialog.Builder builder = new SingleButtonDialog.Builder(activity);
                builder.setPositiveButton(new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {

                        System.exit(0);
                    }
                });
                builder.Create(msg).show();
            }

            @Override
            public void onInitError(String _strError) {

                ChannelSDK.getInstance().SDKInitFail(_strError);
                SDKEntry.getSdkInstance().initCall.onInitError(_strError);

                SingleButtonDialog.Builder builder = new SingleButtonDialog.Builder(activity);
                builder.setPositiveButton(new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {

                        System.exit(0);

                    }
                });
                builder.Create(_strError).show();
            }

            @Override
            public void onGetOaid(boolean isSuccess, String oaid) {

            }

            @Override
            public void onShowGameExit() {

            }

        });

        SDKSettings.isSimulator = InspectSimulator.isSimulator(activity);
        Log.i("idSimu:",SDKSettings.isSimulator);
    }
    public void yyrhLogin(Activity activity){
        SharedPreferences sp = activity.getSharedPreferences("xiyuan", Activity.MODE_PRIVATE);
        if (!Utils.judgeStrNull(sp.getString("username", "")) &&
                !SDKSettings.LOGINTAG.equals(LOGOUT)) {
            yyrhAutoLogin(activity);

        }
        else {
            xy_showLoginDialog(activity);
        }
    }

    private void xy_showLoginDialog(Activity activity) {
        destroyFloat();
        final ConstantDialog  constantDialog = (new ConstantDialog(activity,ResourceUtil.getStyleId(activity,"xy_base_dialog")));
        constantDialog.show();
    }

    private void yyrhAutoLogin(final Activity activity) {

        AutoLoginDialog.Builder builder = new AutoLoginDialog.Builder(activity);
        builder.setPositiveButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //取消回调
                dialog.dismiss();

                xy_showLoginDialog(activity);

            }
        }).setCloseDialogCallback(new AutoLoginDialog.CloseDialogCallback(){

            @Override
            public void onclose() {
                //成功回调
//                constantDialog.dismiss();
            }
        });

        builder.Create().show();
    }
    public void yyrhLogout(){

        if (sScheduledWorker != null) {
            sScheduledWorker.cancel();
            NetRequestApi.rnUserAction("0");
        }

        SDKSettings.loginData = null;
        Activity activity  = (Activity)context;
        activity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                destroyFloat();
            }

        });

        SDKSettings.LOGINTAG = LOGOUT;
        SDKEntry.getSdkInstance().logoutCall.onLogoutSuccess();

    }
    public void yyrhOpenFloatView(final Activity activity){
        if (isOpenFloatView != true){
            return;
        }
        itemList.clear();

        final int[] menuIcons = new int[]{ResourceUtil.getMipmapId(activity,"xy_user_center_icon"),ResourceUtil.getMipmapId(activity,"xy_switch_account_icon"), ResourceUtil.getMipmapId(activity,"xy_hide_icon")};



        itemList.add(new FloatItem(MENU_ITEMS[0], 0x99000000, 0x99000000, BitmapFactory.decodeResource(activity.getResources(), menuIcons[0]), String.valueOf(0)));
        itemList.add(new FloatItem(MENU_ITEMS[1], 0x99000000, 0x99000000, BitmapFactory.decodeResource(activity.getResources(), menuIcons[1]), String.valueOf(0)));
        itemList.add(new FloatItem(MENU_ITEMS[2], 0x99000000, 0x99000000, BitmapFactory.decodeResource(activity.getResources(), menuIcons[2]), String.valueOf(0)));

        if (mFloatMenu == null) {
            mFloatMenu = new FloatLogoMenu.Builder()
                    .withActivity(activity)
//                    .withContext(mActivity.getApplication())//这个在7.0（包括7.0）以上以及大部分7.0以下的国产手机上需要用户授权，需要搭配<uses-permission android:name="android.permission.SYSTEM_ALERT_WINDOW"/>
                    .logo(BitmapFactory.decodeResource(activity.getResources(),ResourceUtil.getMipmapId(activity,"xy_float_icon")))
                    .drawCicleMenuBg(true)
                    .backMenuColor(0xffe4e3e1)
                    .setBgDrawable(activity.getResources().getDrawable(ResourceUtil.getDrawableId(activity,"xy_game_float_menu_bg")))
                    //这个背景色需要和logo的背景色一致
                    .setFloatItems(itemList)
                    .defaultLocation(FloatLogoMenu.LEFT)
                    .drawRedPointNum(false)
                    .showWithListener(new FloatMenuView.OnMenuClickListener() {
                        @Override
                        public void onItemClick(int position, String title) {

                            itemList.set(position,new FloatItem(MENU_ITEMS[position], 0x99000000, 0x99000000, BitmapFactory.decodeResource(activity.getResources(), menuIcons[position]), String.valueOf(0)));

                            if (title.equals("隐藏")){
                                destroyFloat();
                                itemList.clear();

                            }else if (title.equals("切换账号")){
                                yyrhLogout();
                            }else if (title.equals("用户中心")){

                                new WvPageListDialog(activity,ResourceUtil.getStyleId(activity,"xy_base_dialog"),"用户中心",SDKSettings.loginData.user_center).show();
                                mFloatMenu.hideMenu();
                            }
                            else{
                                mFloatMenu.hide();
                                mFloatMenu.show();

                            }


                        }

                        @Override
                        public void dismiss() {

                        }
                    });




        }
    }


    public void yyrhPay(Activity activity,HashMap<String, Object> map){


        String url = (String) map.get("url");
        if (Utils.judgeStrNull(url)){
            return;
        }
        new WvPayYyrhDialog(activity,ResourceUtil.getStyleId(activity,"xy_base_dialog"),url,map).show();



    }

    public void yyrhExitGame(final Activity activity){
        CustomExitGameDialog.Builder builder = new CustomExitGameDialog.Builder(activity);
        builder.setPositiveButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                NetRequestApi.rnUserAction("0");
                dialog.dismiss();
                SDKEntry.getSdkInstance().adSdkCallback.onExitGame(activity);
                SDKEntry.getSdkInstance().exitCall.onExit(true);
            }
        });
        builder.setnegativeButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });

        builder.Create().show();
    }
    public void uploadRoleInfo(String type, Activity activity,
                               String roleId, String roleName, String roleLevel, String serverId,
                               String serverName, String hasGold, String vipLevel,String role_power,String partyId,String partyName, String createTime,String charge){
        NetRequestApi.upLoadingRoleInfo(type, activity, roleId,roleName,roleLevel,serverId,
                serverName, hasGold, vipLevel,role_power, partyId, partyName, createTime,charge);

    }

    public void saveUserLoginInfo(final Context context, final String account, String pwd, final String token){
        SharedPreferences sp = context
                .getSharedPreferences("xiyuan",
                        Activity.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        editor.putString("username", account);
        editor.putString("password", pwd);
        editor.commit();

        String timeStamp = System.currentTimeMillis() + "";

        String delete_sql = "delete from user where name = '" + account + "'";

        String insert_sql = "insert into user(name,pwd,time) values('" + account
                + "','" + pwd + "','" + timeStamp + "')";

        DatabaseHelper.excuteSql(context, delete_sql);
        DatabaseHelper.excuteSql(context, insert_sql);


        if (isOpenRealName){

            if (!isVefityRealName){



                    new WvPageListDialog(context, ResourceUtil.getStyleId(context, "xy_base_dialog"), "实名认证", SDKSettings.loginData.authentication,
                            new WvPageListDialog.OnClosePageListener() {
                                @Override
                                public void onClose() {

                                    showLoginSuccessUi(token,account);
                                }

                                @Override
                                public void onRealNameSuccess(String birthday) {
                                    showLoginSuccessUi(token,account);
                                }
                            },SDKSettings.isForceRealName).show();
                }else {
                showLoginSuccessUi(token,account);
                }



        }else{


            showLoginSuccessUi(token,account);
        }
}

    private void  showLoginSuccessUi(String token,String account){
        openFloatViewInUIThread((Activity) context);
        SDKEntry.getSdkInstance().loginCall.onLoginSuccess(token);
        SDKEntry.getSdkInstance().adSdkCallback.onLoginSuccess(account);
        startRoleOnlineWorker();
    }


    private void openFloatViewInUIThread(final Activity gameAct){
        gameAct.runOnUiThread(new Runnable() {
            @Override
            public void run() {

                YyrhSdkManager.defaultManager(gameAct).yyrhOpenFloatView(gameAct);
            }
        });
    }

    public void onResume(Activity activity){

        if (mFloatMenu != null) {

            mFloatMenu.show();
        }

    }
    public void onPause(Activity activity){

        hideFloat();
    }
    public void onDestroy(Activity activity){
        itemList.clear();
        mFloatMenu = null;
        if (sScheduledWorker != null) {
            sScheduledWorker.cancel();
        }
    }

    public void hideFloat() {
        if (mFloatMenu != null) {
            mFloatMenu.hide();
        }
    }

    public void destroyFloat() {
        if (mFloatMenu != null) {
            mFloatMenu.destoryFloat();
        }
        itemList.clear();
        mFloatMenu = null;

    }

    private void startRoleOnlineWorker(){
        if (Utils.judgeStrNull(SDKSettings.loginData.rn_si)){
            YYLog.i(" rn_si is null");
            return;
        }
        if (sScheduledWorker == null) {
            sScheduledWorker = new ScheduledWorker(1);
        }
        sScheduledWorker.cancel();
        int time = initConfig.rn_bh;
        YYLog.i(" ------ 开始防沉迷计时任务  : " + time);
        sScheduledWorker.invokeAtFixedRate(new Runnable() {
            @Override
            public void run() {

                YYLog.i(" ------ 用户角色心跳 ------");

                NetRequestApi.rnUserAction("2");

            }
        }, time, time, TimeUnit.SECONDS);
    }
}
