package com.yyrh.ui;

import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.util.Log;
import android.util.TypedValue;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.yyrh.networking.NetRequestApi;
import com.yyrh.sdk.YyrhSdkManager;
import com.yyrh.sdk.callback.LoginCallback;

import com.yyrh.utils.ResourceUtil;
import com.yyrh.utils.TosUtil;

import java.util.Timer;
import java.util.TimerTask;


public class AutoLoginDialog extends Dialog {

	private	static Button bt_exit_game;

	private	static TextView autoLogin_text;
	private static AutoLoginDialog dialog;
	private static Timer timer;





	public AutoLoginDialog(Context context, int theme) {
		super(context, theme);
		initView();
	}
	private void initView(){

	}


	public  static class  Builder{
		private Context context;
		private OnClickListener positiveButtonClickListener;
		private CloseDialogCallback closeDialogCallback;
		private ImageView autoLogin_icon;
		public Builder(Context context){ this.context = context;}
		public Builder setPositiveButton(OnClickListener listener){
			this.positiveButtonClickListener = listener;
			return this;
		}
		public Builder setCloseDialogCallback(CloseDialogCallback closeDialogCallback){
			this.closeDialogCallback = closeDialogCallback;
			return this;
		}


		public void  dialogDismiss(){
		    if (timer != null){
                timer.cancel();
            }

			dialog.dismiss();

		}
		public AutoLoginDialog Create(){
			{

				dialog = new AutoLoginDialog(context,ResourceUtil.getStyleId(context,"xy_base_dialog"));

				LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);

				View layout =  inflater.inflate(ResourceUtil.getLayoutId(context, "xy_auto_login_dialog"),null);

				dialog.addContentView(layout,new ViewGroup.LayoutParams(dp2Px(310,context),dp2Px(130,context)));

				bt_exit_game =dialog.findViewById(ResourceUtil.getId(context,
						"xy_autoLogin_cancel_Btn"));

				autoLogin_text =dialog.findViewById(ResourceUtil.getId(context,
						"xy_autoLogin_text"));

				autoLogin_icon = dialog.findViewById(ResourceUtil.getId(context, "xy_autoLogin_icon"));
				Animation rotateAnimation = AnimationUtils.loadAnimation(context, ResourceUtil.getAnimId(context, "xy_rotate_anim"));
				autoLogin_icon.startAnimation(rotateAnimation);


				if (bt_exit_game!=null){
					bt_exit_game.setOnClickListener(new View.OnClickListener() {
						@Override
						public void onClick(View view) {
							if (timer != null){
								timer.cancel();
							}

							timer = null;
							positiveButtonClickListener.onClick(dialog,DialogInterface.BUTTON_POSITIVE);
						}
					});
				}

				SharedPreferences sp = context.getSharedPreferences("xiyuan", Activity.MODE_PRIVATE);
				String autoTip = sp.getString("username", "") + ",自动登录中..." ;
				autoLogin_text.setText(autoTip);
                dialog.setCancelable(false);
				timer = new Timer();
				timer.schedule(task, 2000);

				return dialog;

			}
		}



		TimerTask  task = new TimerTask() {

			@Override
			public void run() {

				dialogDismiss();

				SharedPreferences sp = context.getSharedPreferences("xiyuan", Activity.MODE_PRIVATE);
				final String account = sp.getString("username", "");
				final String pwd = sp.getString("password", "");
				NetRequestApi.loginWithYy(true,(Activity) context,account,pwd, new LoginCallback() {
					@Override
					public void onLoginSuccess(String token) {




						closeDialogCallback.onclose();

						YyrhSdkManager.defaultManager(context).saveUserLoginInfo(context,account,pwd,token);

					}

					@Override
					public void onLoginFailed(String msg) {
						new TosUtil(context,"blue",  msg).show();

						dialogDismiss();
					}

					@Override
					public void onLoginError(String msg) {
						new TosUtil(context,"blue",  msg).show();

						dialogDismiss();
					}
				});
			}

		};


	}



	public interface CloseDialogCallback {
		public void onclose();
	}
	public static int dp2Px(float dp, Context mContext) {
		return (int) TypedValue.applyDimension(
				TypedValue.COMPLEX_UNIT_DIP,
				dp,
				mContext.getResources().getDisplayMetrics());
	}

}
