package com.yyrh.ui;

import android.app.Activity;
import android.content.Context;

import android.content.SharedPreferences;
import android.os.CountDownTimer;
import android.text.method.HideReturnsTransformationMethod;
import android.text.method.PasswordTransformationMethod;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;

import com.yyrh.constant.SDKSettings;
import com.yyrh.networking.NetRequestApi;
import com.yyrh.ui.userlist.DatabaseHelper;
import com.yyrh.utils.ResourceUtil;
import com.yyrh.utils.TosUtil;
import com.yyrh.utils.Utils;

public class ForgetPwdLayout implements View.OnClickListener {


    private Context context;
    private ConstantDialog constantDialog;
    private EditText et_user_phone,et_user_code,et_user_pwd;
    private Button btn_get_code,reg_compete_btn;
    private ImageView down_eye_btn, close_btn;
    private boolean isShowPwd = false;
    public ForgetPwdLayout(Context context, ConstantDialog constantDialog){

        this.context = context;
        this.constantDialog = constantDialog;
        if (SDKSettings.isLandscape){
            constantDialog.setContentView(ResourceUtil.getLayoutId(context, "xy_phone_find_pwd_dialog"));
        }else{
            constantDialog.setContentView(ResourceUtil.getLayoutId(context, "xy_phone_find_pwd_dialog_protrait"));
        }


        et_user_phone = constantDialog.findViewById(ResourceUtil.getId(context, "et_user_phone"));
        et_user_code = constantDialog.findViewById(ResourceUtil.getId(context, "et_user_code"));
        et_user_pwd  = constantDialog.findViewById(ResourceUtil.getId(context, "et_user_pwd"));
        btn_get_code  = constantDialog.findViewById(ResourceUtil.getId(context, "btn_get_code"));
        reg_compete_btn  = constantDialog.findViewById(ResourceUtil.getId(context, "reg_compete_btn"));
        down_eye_btn  = constantDialog.findViewById(ResourceUtil.getId(context, "down_eye_btn"));

        close_btn  = constantDialog.findViewById(ResourceUtil.getId(context, "close_btn"));
        down_eye_btn.setOnClickListener(this);
        btn_get_code.setOnClickListener(this);
        close_btn.setOnClickListener(this);
        reg_compete_btn.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        int id = v.getId();
        if (id == ResourceUtil.getId(context, "btn_get_code")) {
            String phone =  et_user_phone.getText().toString();

            if (phone.length() < 10) {
                new TosUtil(context,"blue", context.getString(ResourceUtil.getStringId(context, "xy_pls_input_right_phone"))).show();
                return;
            }
            getPhoneCaptcha((Activity) context,phone,"modify_pwd");
        }else if (id == ResourceUtil.getId(context, "reg_compete_btn")) {
            String phone =  et_user_phone.getText().toString();
            String code = et_user_code.getText().toString();
            final String pwd = et_user_pwd.getText().toString();
            if (phone.length() < 10) {

                new TosUtil(context,"blue",  context.getString(ResourceUtil.getStringId(context, "xy_pls_input_right_phone"))).show();

                return;
            }
            if(code.length() < 4 || Utils.judgeStrNull(code))
            {
                new TosUtil(context,"blue",  context.getString(ResourceUtil.getStringId(context, "xy_pls_input_right_code"))).show();


                return;
            }
            if(pwd.length() < 6 || Utils.judgeStrNull(pwd))
            {
                new TosUtil(context,"blue",  context.getString(ResourceUtil.getStringId(context, "xy_pwd_limit_6"))).show();

                return;
            }
            resetPwdWithPhone((Activity) context,phone,code,pwd);

        }else if (id == ResourceUtil.getId(context, "close_btn")) {
            new LoginLayout(context,constantDialog);
        }else if (id == ResourceUtil.getId(context, "down_eye_btn")) {
            if (!isShowPwd) {
                isShowPwd = true;
                et_user_pwd.setTransformationMethod(HideReturnsTransformationMethod.getInstance());
                down_eye_btn.setImageResource(ResourceUtil.getMipmapId(context, "xy_eye_icon_select"));
            } else {
                isShowPwd = false;
                et_user_pwd.setTransformationMethod(PasswordTransformationMethod.getInstance());
                down_eye_btn.setImageResource(ResourceUtil.getMipmapId(context, "xy_eye_icon_normal"));
            }
        }

    }

    private void  getPhoneCaptcha(Activity activity, String phone, String action){
        NetRequestApi.getPhoneCaptcha(activity, phone, action, new PhoneRegisterLayout.CaptchaCallback() {
            @Override
            public void onGetSuccess(String msg) {
                getCodeSuccess();
                new TosUtil(context,"green", context.getString(ResourceUtil.getStringId(context, "xy_send_code_success"))).show();


            }

            @Override
            public void onGetFailed(String msg) {
                new TosUtil(context,"blue", msg).show();

            }
        });
    }

    private void resetPwdWithPhone(Activity activity, final String phone, String code, final String pwd) {
        NetRequestApi.resetPwdWithPhone(activity, phone, code, pwd, new ResetPwdCallback() {
            @Override
            public void onResetSuccess(String msg) {

                SharedPreferences sp = context
                        .getSharedPreferences("xiyuan",
                                Activity.MODE_PRIVATE);
                SharedPreferences.Editor editor = sp.edit();
                editor.putString("username", phone);
                editor.putString("password", pwd);
                editor.commit();
                String timeStamp = System.currentTimeMillis() + "";
                String delete_sql = "delete from user where name = '" + phone + "'";
                String insert_sql = "insert into user(name,pwd,time) values('" + phone
                        + "','" + pwd + "','" + timeStamp + "')";

                DatabaseHelper.excuteSql(context, delete_sql);
                DatabaseHelper.excuteSql(context, insert_sql);
                new LoginLayout(context,constantDialog);

                new TosUtil(context,"green", msg).show();

            }

            @Override
            public void onResetFailed(String msg) {

                new TosUtil(context,"blue",  msg).show();

            }
        });
    }

    private void getCodeSuccess() {
        btn_get_code.setEnabled(false);
        btn_get_code.setText("60s");
        btn_get_code.setBackgroundResource(ResourceUtil.getDrawableId(context,"xy_radius_main_color_1dp"));
        TimeCount time = new TimeCount(60000, 1000);
        time.start();
    }

    class TimeCount extends CountDownTimer {

        public TimeCount(long millisInFuture, long countDownInterval) {
            super(millisInFuture, countDownInterval);
            // TODO Auto-generated constructor stub
        }

        @Override
        public void onTick(long millisUntilFinished) {
            // TODO Auto-generated method stub
            btn_get_code.setText(millisUntilFinished / 1000 + "s");

        }

        @Override
        public void onFinish() {
            // TODO Auto-generated method stub
            btn_get_code.setEnabled(true);
            btn_get_code.setBackgroundResource(ResourceUtil.getDrawableId(context,"xy_radius_main_color_1dp"));
            btn_get_code.setText(ResourceUtil.getStringId(context, "xy_get_phone_code"));
        }

    }
    public interface ResetPwdCallback {

        void onResetSuccess(String msg);
        void onResetFailed(String msg);


    }
}
