package com.yyrh.ui;

import android.app.Activity;
import android.content.Context;
import android.graphics.Paint;
import android.os.CountDownTimer;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;

import com.yyrh.constant.SDKSettings;
import com.yyrh.constant.URLConstants;
import com.yyrh.sdk.SDKEntry;
import com.yyrh.sdk.YyrhSdkManager;
import com.yyrh.ui.floatmenu.WvPageListDialog;
import com.yyrh.utils.ResourceUtil;
import com.yyrh.utils.ScreenShotUtil;
import com.yyrh.utils.TosUtil;
import com.yyrh.utils.Utils;
import com.yyrh.networking.NetRequestApi;
import com.yyrh.sdk.callback.RegisterCallback;

public class RegisterLayout implements View.OnClickListener {


    private ConstantDialog constantDialog;
    private Context context;
    private EditText accountEdit,registPwdEdit;
    private Button backToLogin,registCompete,reg_phone_btn;
    private CheckBox cb_register;
    private TextView tv_tip,tv_private_policy;
    public RegisterLayout(Context context,ConstantDialog constantDialog){
        this.constantDialog = constantDialog;
        this.context = context;
        if (SDKSettings.isLandscape){
            constantDialog.setContentView(ResourceUtil.getLayoutId(context, "xy_register_dialog"));
        }else{
            constantDialog.setContentView(ResourceUtil.getLayoutId(context, "xy_register_dialog_protrait"));
        }



        backToLogin =  constantDialog.findViewById(ResourceUtil.getId(context, "reg_back_btn"));
        registCompete =  constantDialog.findViewById(ResourceUtil.getId(context, "reg_compete_btn"));

        accountEdit = constantDialog.findViewById(ResourceUtil.getId(context, "reg_account_edit"));
        registPwdEdit = constantDialog.findViewById(ResourceUtil.getId(context, "reg_pwd_edit"));

        cb_register = constantDialog.findViewById(ResourceUtil.getId(context, "cb_register"));
        tv_tip = constantDialog.findViewById(ResourceUtil.getId(context, "tv_tip"));
        tv_tip.getPaint().setFlags(Paint. UNDERLINE_TEXT_FLAG );
        tv_tip.getPaint().setAntiAlias(true);

        tv_private_policy = constantDialog.findViewById(ResourceUtil.getId(context, "tv_private_policy"));
        tv_private_policy.getPaint().setFlags(Paint. UNDERLINE_TEXT_FLAG );
        tv_private_policy.getPaint().setAntiAlias(true);
        tv_private_policy.setOnClickListener(this);


        reg_phone_btn = constantDialog.findViewById(ResourceUtil.getId(context, "reg_phone_btn"));

        accountEdit.setText("xy" + Utils.getRandom(7));
        registPwdEdit.setText(Utils.getRandom(7));
        backToLogin.setOnClickListener(this);
        registCompete.setOnClickListener(this);
        tv_tip.setOnClickListener(this);
        reg_phone_btn.setOnClickListener(this);

        if (SDKSettings.isHideFunctionsOfPhone){
            reg_phone_btn.setVisibility(View.GONE);
        }

    }

    @Override
    public void onClick(View v) {
        int id = v.getId();
        if (id == ResourceUtil.getId(context, "reg_compete_btn")) {

            registerInterval();
            startRegister(accountEdit.getText().toString(), registPwdEdit.getText().toString());
        }else if (id == ResourceUtil.getId(context, "reg_back_btn")) {

            new LoginLayout(context,constantDialog);
        }
        else if (id == ResourceUtil.getId(context, "tv_tip")) {


            new WvPageListDialog(context,ResourceUtil.getStyleId(context,"xy_base_dialog"),"用户服务协议",SDKSettings.initConfig.agreement_user).show();

        }else if (id == ResourceUtil.getId(context, "tv_private_policy")) {




            new WvPageListDialog(context,ResourceUtil.getStyleId(context,"xy_base_dialog"),"隐私政策",SDKSettings.initConfig.agreement_privacy).show();

        }else if (id == ResourceUtil.getId(context, "reg_phone_btn")) {
//            new TosUtil(context,"blue", context.getString(ResourceUtil.getStringId(context, "xy_function_unopen"))).show();

            new PhoneRegisterLayout(context,constantDialog);
        }
    }

    private void startRegister(final String account, final String pwd) {
        if (!cb_register.isChecked()){

            new TosUtil(context,"blue", context.getString(ResourceUtil.getStringId(context, "xy_pls_checked_reg_tip"))).show();

            return;
        }
        if (Utils.judgeStrNull(account)){
            new TosUtil(context,"blue",  context.getString(ResourceUtil.getStringId(context, "xy_band_need_account"))).show();



            return;
        }
        if (Utils.isNumeric(account)){
            new TosUtil(context,"blue",  context.getString(ResourceUtil.getStringId(context, "xy_acount_not_only_number"))).show();

            return;
        }
        if (Utils.judgeStrNull(pwd)){
            new TosUtil(context,"blue",  context.getString(ResourceUtil.getStringId(context, "xy_band_need_pwd"))).show();


            return;
        }

        if (account.length() < 6 || pwd.length() > 20) {
            new TosUtil(context,"blue",  context.getString(ResourceUtil.getStringId(context, "xy_regist_account_error"))).show();


            return;
        }

        if (pwd.length() < 6 || pwd.length() > 20) {

            new TosUtil(context, "blue", context.getString(ResourceUtil.getStringId(context, "xy_regist_pwd_error"))).show();
            return;
        }



        NetRequestApi.registerWithYy((Activity) context, account, pwd, new RegisterCallback() {
            @Override
            public void onRegisterSuccess(String token) {


                if (ScreenShotUtil.shotByDialog(context,constantDialog)){
                    new TosUtil(context,"green",  context.getString(ResourceUtil.getStringId(context, "xy_register_screen_tip"))).show();


                }

                constantDialog.dismiss();
                SDKSettings.isVefityRealName = false;
                YyrhSdkManager.defaultManager(context).saveUserLoginInfo(context,account,pwd,token);
                SDKEntry.getSdkInstance().adSdkCallback.onRegisterSuccess(account);
            }

            @Override
            public void onRegisterFailed(String msg) {

                new TosUtil(context,"blue",  msg).show();


            }

        });
    }

    private void registerInterval() {


        registCompete.setEnabled(false);
        registCompete.setText("3s");
        registCompete.setBackgroundResource(ResourceUtil.getDrawableId(context,"xy_radius_deepgray_bg"));
        TimeCount time = new TimeCount(3000, 1000);
        time.start();
    }

    class TimeCount extends CountDownTimer {

        public TimeCount(long millisInFuture, long countDownInterval) {
            super(millisInFuture, countDownInterval);
            // TODO Auto-generated constructor stub
        }

        @Override
        public void onTick(long millisUntilFinished) {
            // TODO Auto-generated method stub
            registCompete.setText(millisUntilFinished / 1000 + "s");

        }

        @Override
        public void onFinish() {
            // TODO Auto-generated method stub
            registCompete.setEnabled(true);
            registCompete.setBackgroundResource(ResourceUtil.getDrawableId(context,"xy_radius_main_color_bg"));
            registCompete.setText(ResourceUtil.getStringId(context, "xy_register_success"));
        }

    }
}

